//+------------------------------------------------------------------+
//|                    *  MA + Trend Detector  *                     |
//|                           version  0.1                           |
//|                                                                  |
//|  Copyright  2007 Sanders  sampler-fos@mail.ru   ICQ:458041164   |
//|  Trend Detector by Leonid553    http://www.tradersforum.net.ru   |
//+------------------------------------------------------------------+
//  
//       SMMA 
#property copyright "Sanders"
#property link      "sampler-fos@mail.ru"

extern string   _____= "  "; 
extern int    MAfast     = 6;
extern int    MAslow     = 21;
extern double   DV_long    = 0;
extern int    TakeProfit = 10;
extern int    StopLoss   = 50;
extern int    lMinProfit = 51;
extern int    lTrailingStop = 58;
extern int    lTrailingStep = 20;
extern string   ____= "  ";
extern int    MAfast_     = 6;
extern int    MAslow_     =21;
extern double    DV_short    = 0;
extern int    TakeProfit_ = 10;
extern int    StopLoss_   = 50;
extern int    sMinProfit = 20;
extern int    sTrailingStop = 53;
extern int    sTrailingStep = 4;

extern string   _= "   ";
extern double Lots       = 0.1;
int           SlipPage   = 3;
extern bool   UseTrailing = true;
extern bool   UseTrend     = false;
extern int    PeriodPower  = 13;
extern int    Period_Bulls = 11;
extern int    Period_Bears = 10;
extern bool   AutoClose =true;// 
extern int    Stochastic_period = 13;
extern int    Up_lim = 80;
extern int    Low_lim = 20;
int Magic = 1456;
int prevtime=0;
double fast1,fast2,slow1,slow2,fast1_,fast2_,slow1_,slow2_;
bool buy=false,sell=false;
datetime Cur;

//+------------------------------------------------------------------+
//| Expert Start Function                                            |
//+------------------------------------------------------------------+
int start()
 {Comment( slow1); 
if(Time[0]==prevtime) return(0);
 prevtime = Time[0];
  if (UseTrailing) TrailPositions(); 
 //----    ------------ 
  fast1=iCustom(NULL,0,"NonLagMA_v5",0, MAfast,0,0,0,0,0,0,0); 
  fast2=iCustom(NULL,0,"NonLagMA_v5",0, MAfast,0,0,0,0,0,0,1); 
   
  slow1 =iCustom(NULL,0,"NonLagMA_v5",0,MAslow,0,0,0,0,DV_long,0,0);
  slow2 =iCustom(NULL,0,"NonLagMA_v5",0,MAslow,0,0,0,0,DV_long,0,1);
  //----    ------------ 
  fast1_=iCustom(NULL,0,"NonLagMA_v5",0, MAfast_,0,0,0,0,0,0,0); 
  fast2_=iCustom(NULL,0,"NonLagMA_v5",0, MAfast_,0,0,0,0,0,0,1); 

  slow1_ =iCustom(NULL,0,"NonLagMA_v5",0,MAslow_,0,0,0,0,DV_short,0,0);
  slow2_ =iCustom(NULL,0,"NonLagMA_v5",0,MAslow_,0,0,0,0,DV_short,0,1);
  //------------------------------------------------------
  buy=false; sell=false;
  if (AutoClose) {  
//----    ----
double Stochast_0 =iStochastic(NULL,0,Stochastic_period,3,3,MODE_SMA,0,MODE_MAIN,0);
double Stochast_1 =iStochastic(NULL,0,Stochastic_period,3,3,MODE_SMA,0,MODE_MAIN,1);
//----------------------------------------------------------------------
  for (int v=0; v<OrdersTotal(); v++)                             {       
      if (OrderSelect(v, SELECT_BY_POS, MODE_TRADES))               {           
        if (OrderSymbol()==Symbol()&& OrderMagicNumber()==Magic)   { 
//-----------------------------------------------------                  
if (OrderType() == OP_BUY) { 
      if(Stochast_1>=Up_lim && Stochast_0<Up_lim)     {
         Print ( OrderClose(OrderTicket(),OrderLots(),Bid,3,Green)); //  
                 return(0); // 
         
              }       
     }  
 //--------------------------------------------------------
if (OrderType() == OP_SELL) { 
      if(Stochast_1<=Low_lim && Stochast_0>Low_lim)    {
               Print  (OrderClose(OrderTicket(),OrderLots(),Ask,3,Green)); //  
                 return(0); // 
       
              }       
     }  
 //-------------------------------------------------------                       
    }  // Symbol()  
  } // select
 } //total
} //Close_ 
 //****************************************************************************   

  if(!UseTrend)
   {
    if(fast2<=slow2   && fast1>slow1)   buy=true;
    if(fast2_>=slow2_ && fast1_<slow1_) sell=true;
   }

  if(UseTrend)
   {
    double Bears_array[30]; int cx=0; while (cx<31)
    {Bears_array[cx]= iBearsPower(NULL, 0, PeriodPower,PRICE_CLOSE,cx); cx++; }
    ArraySetAsSeries(Bears_array,true);
    double MA_Bears =iMAOnArray(Bears_array,0,Period_Bears,1,MODE_SMMA,0);
     double MA_Bears_1 =iMAOnArray(Bears_array,0,Period_Bears,1,MODE_SMMA,1);
 
    double Bulls_array[30]; int lx=0; while (lx<31)
    {Bulls_array[lx]= iBullsPower(NULL, 0, PeriodPower,PRICE_CLOSE,lx); lx++; } 
    ArraySetAsSeries(Bulls_array,true);
    double MA_Bulls =iMAOnArray(Bulls_array,0,Period_Bulls,1,MODE_SMMA,0); 
    double MA_Bulls_1 =iMAOnArray(Bulls_array,0,Period_Bulls,1,MODE_SMMA,1);
    
    double Delta = MA_Bears+MA_Bulls;

    if(fast2<=slow2 && fast1>slow1 && Delta>=0) buy=true;
    if(fast2_>=slow2_ && fast1_<slow1_ && Delta<=0) sell=true;
   }
  
  if(buy && AccountFreeMarginCheck(Symbol(),OP_BUY,Lots)>0 && 
      IsTradeAllowed()==true && TimeCurrent()-Cur>Period()*60)
   {
    OrderSend(Symbol(),OP_BUY,Lots,Ask,SlipPage,Ask-StopLoss*Point,
                           Ask+TakeProfit*Point,"Buy",Magic,0,Blue);
    Cur=TimeCurrent();
   }
            
  if(sell && AccountFreeMarginCheck(Symbol(),OP_SELL,Lots)>0 && 
           IsTradeAllowed()==true && TimeCurrent()-Cur>Period()*60)
   {
    OrderSend(Symbol(),OP_SELL,Lots,Bid,SlipPage,Bid+StopLoss_*Point,
                              Bid-TakeProfit_*Point,"Sell",Magic,0,Red); 
    Cur=TimeCurrent();
   }
   
  return(0);
 }
//-------------------------------------------------------------------------------+
 void TrailPositions() 
{
 int Orders = OrdersTotal();
  for (int i=0; i<Orders; i++) {
    if (!(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))) continue;
    if (OrderSymbol() != Symbol()) continue;  
    if (OrderType() == OP_BUY) {
      if (Bid-OrderOpenPrice() > lMinProfit*Point) {
        if (OrderStopLoss() < Bid-(lTrailingStop+lTrailingStep-1)*Point) {
          OrderModify(OrderTicket(), OrderOpenPrice(), Bid-lTrailingStop*Point,
                                                    OrderTakeProfit(), 0, Blue);
      }}}
    if (OrderType() == OP_SELL) {
      if (OrderOpenPrice()-Ask > sMinProfit*Point) {
        if (OrderStopLoss() > Ask+(sTrailingStop+sTrailingStep-1)*Point ||
                                                         OrderStopLoss() == 0) {
          OrderModify(OrderTicket(), OrderOpenPrice(), Ask+sTrailingStop*Point,
                                                      OrderTakeProfit(), 0, Blue);
        }}}}}
//-----------------------------------------------------------------------